]> arthur.barton.de Git - bup.git/blobdiff - main.py
helpers: rename realpath to resolve_parent
[bup.git] / main.py
diff --git a/main.py b/main.py
index 3554179d4c5a5272b2c6ec2960443fc528a30ab5..b149bbad76cbe49643792a6cf50be58864eb492e 100755 (executable)
--- a/main.py
+++ b/main.py
@@ -1,4 +1,10 @@
-#!/usr/bin/env python
+#!/bin/sh
+"""": # -*-python-*- # -*-python-*-
+bup_python="$(dirname "$0")/cmd/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
+"""
+# end of bup preamble
+
 import sys, os, subprocess, signal, getopt
 
 argv = sys.argv
@@ -74,7 +80,7 @@ if len(argv) < 2:
 try:
     optspec = ['help', 'version', 'debug', 'profile', 'bup-dir=']
     global_args, subcmd = getopt.getopt(argv[1:], '?VDd:', optspec)
-except getopt.GetoptError, ex:
+except getopt.GetoptError as ex:
     usage('error: %s' % ex.msg)
 
 help_requested = None
@@ -151,19 +157,29 @@ else:
     outf = None
     errf = None
 
+ret = 95
+p = None
+forward_signals = True
 
-class SigException(Exception):
-    def __init__(self, signum):
-        self.signum = signum
-        Exception.__init__(self, 'signal %d received' % signum)
 def handler(signum, frame):
-    raise SigException(signum)
+    debug1('\nbup: signal %d received\n' % signum)
+    if not p or not forward_signals:
+        return
+    if signum != signal.SIGTSTP:
+        os.kill(p.pid, signum)
+    else: # SIGTSTP: stop the child, then ourselves.
+        os.kill(p.pid, signal.SIGSTOP)
+        signal.signal(signal.SIGTSTP, signal.SIG_DFL)
+        os.kill(os.getpid(), signal.SIGTSTP)
+        # Back from suspend -- reestablish the handler.
+        signal.signal(signal.SIGTSTP, handler)
+    ret = 94
 
 signal.signal(signal.SIGTERM, handler)
 signal.signal(signal.SIGINT, handler)
+signal.signal(signal.SIGTSTP, handler)
+signal.signal(signal.SIGCONT, handler)
 
-ret = 95
-p = None
 try:
     try:
         c = (do_profile and [sys.executable, '-m', 'cProfile'] or []) + subcmd
@@ -176,14 +192,10 @@ try:
         while 1:
             # if we get a signal while waiting, we have to keep waiting, just
             # in case our child doesn't die.
-            try:
-                ret = p.wait()
-                break
-            except SigException, e:
-                log('\nbup: %s\n' % e)
-                os.kill(p.pid, e.signum)
-                ret = 94
-    except OSError, e:
+            ret = p.wait()
+            forward_signals = False
+            break
+    except OSError as e:
         log('%s: %s\n' % (subcmd[0], e))
         ret = 98
 finally: